# -*- coding: utf-8 -*-
##############################################################################
#
#    Email marketing click & read tracker
#    Copyright (C) 2011 Florent Aide, <florent.aide@gmail.com>
#    Copyright (C) 2011 XCG Consulting (http://odoo.consulting)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


{
    "name": "Marketing Campaign Tracker",
    "version": "10.0.3.7",
    "author": "XCG Consulting",
    "category": "Marketing",
    "description": """
This module adds a tracker capability to the marketing campaign module.

It needs a compatible version of bounced running on another server. This server
will need a user with the bounced group to work.
    """,
    "website": "https://odoo.consulting/",
    "depends": [
        "document",
        "mail",
        "decimal_precision",
        "marketing_campaign_streamline",
        "board",
        "static_page",
        "queue",
    ],
    "data": [
        "security/security.xml",
        "views/static_page.xml",
        "views/marketing_campaign.xml",
        "wizard/wizard.xml",
        "report/analytic.xml",
        "report/marketing_campaign_view.xml",
        "security/ir.model.access.csv",
        "views/trackvisit.xml",
        "views/track_event.xml",
        "data/queue.csv",
        "data/static_page.xml",
        "data/ir_cron.xml",
    ],
    "demo": [
        "demo/res.xml",
        "demo/marketing.campaign.tracker.track.csv",
        "demo/marketing.campaign.tracker.trackitem.csv",
        "demo/marketing.campaign.tracker.trackvisit.csv",
    ],
    "complexity": "expert",
    "installable": True,
    "active": False,
}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
