# -*- coding: utf-8 -*-
#
# Documentation build configuration file
#
# This file is execfile()d with the current directory set to its
# containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.

import ast
import ConfigParser
import os
import sys

import odoo

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
sys.path.insert(0, os.path.abspath("."))

# -- General configuration ------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
# needs_sphinx = '1.0' # noqa:E265

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    "sphinx.ext.autodoc",
    "sphinx.ext.doctest",
    "sphinx.ext.intersphinx",
    "sphinx.ext.todo",
    "sphinx.ext.coverage",
    "sphinx.ext.ifconfig",
    "sphinx.ext.viewcode",
    "sphinxodoo.ext.autodoc",
]

# Add any paths that contain templates here, relative to this directory.
templates_path = ["_templates"]

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
# source_suffix = ['.rst', '.md']
source_suffix = ".rst"

# The encoding of source files.
# source_encoding = 'utf-8-sig' # noqa:E265

# The master toctree document.
master_doc = "index"

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
with open(os.path.join("..", "__manifest__.py"), "r") as f:
    read_data = f.read()
d = ast.literal_eval(read_data)
# The full version, including alpha/beta/rc tags.
release = d["version"]
# The short X.Y version.
version = ".".join(release.split(".")[:4])

# General information about the project.
project = d["name"]
copyright = u"2018, XCG Consulting"
author = d["author"]
module_nospace = project.replace(" ", "")
module_description = d.get("summary", "")
module_lowercase = module_nospace.lower()

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

locale_dirs = ["locale"]

# There are two options for replacing |today|: either, you set today to some
# non-false value, then it is used:
# today = '' # noqa:E265
# Else, today_fmt is used as the format for a strftime call.
# today_fmt = '%B %d, %Y' # noqa:E265

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
exclude_patterns = ["_build"]

# The reST default role (used for this markup: `text`) to use for all
# documents.
# default_role = None # noqa:E265

# If true, '()' will be appended to :func: etc. cross-reference text.
# add_function_parentheses = True # noqa:E265

# If true, the current module name will be prepended to all description
# unit titles (such as .. function::).
# add_module_names = True # noqa:E265

# If true, sectionauthor and moduleauthor directives will be shown in the
# output. They are ignored by default.
# show_authors = False # noqa:E265

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = "sphinx"

# A list of ignored prefixes for module index sorting.
# modindex_common_prefix = [] # noqa:E265

# If true, keep warnings as "system message" paragraphs in the built documents.
# keep_warnings = False # noqa:E265

# If true, `todo` and `todoList` produce output, else they produce nothing.
todo_include_todos = True


# -- Options for HTML output ----------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
html_theme = "default"

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
# html_theme_options = {} # noqa:E265

# Add any paths that contain custom themes here, relative to this directory.
# html_theme_path = [] # noqa:E265

# The name for this set of Sphinx documents.  If None, it defaults to
# "<project> v<release> documentation".
# html_title = None # noqa:E265

# A shorter title for the navigation bar.  Default is the same as html_title.
# html_short_title = None # noqa:E265

# The name of an image file (relative to this directory) to place at the top
# of the sidebar.
# html_logo = None # noqa:E265

# The name of an image file (relative to this directory) to use as a favicon of
# the docs.  This file should be a Windows icon file (.ico) being 16x16 or
# 32x32 pixels large.
# html_favicon = None # noqa:E265

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ["_static"]

# Add any extra paths that contain custom files (such as robots.txt or
# .htaccess) here, relative to this directory. These files are copied
# directly to the root of the documentation.
# html_extra_path = [] # noqa:E265

# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
# using the given strftime format.
# html_last_updated_fmt = '%b %d, %Y' # noqa:E265

# If true, SmartyPants will be used to convert quotes and dashes to
# typographically correct entities.
# html_use_smartypants = True # noqa:E265

# Custom sidebar templates, maps document names to template names.
# html_sidebars = {} # noqa:E265

# Additional templates that should be rendered to pages, maps page names to
# template names.
# html_additional_pages = {} # noqa:E265

# If false, no module index is generated.
# html_domain_indices = True # noqa:E265

# If false, no index is generated.
# html_use_index = True # noqa:E265

# If true, the index is split into individual pages for each letter.
# html_split_index = False # noqa:E265

# If true, links to the reST sources are added to the pages.
# html_show_sourcelink = True # noqa:E265

# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
# html_show_sphinx = True # noqa:E265

# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
# html_show_copyright = True # noqa:E265

# If true, an OpenSearch description file will be output, and all pages will
# contain a <link> tag referring to it.  The value of this option must be the
# base URL from which the finished HTML is served.
# html_use_opensearch = '' # noqa:E265

# This is the file name suffix for HTML files (e.g. ".xhtml").
# html_file_suffix = None # noqa:E265

# Language to be used for generating the HTML full-text search index.
# Sphinx supports the following languages:
#   'da', 'de', 'en', 'es', 'fi', 'fr', 'hu', 'it', 'ja'
#   'nl', 'no', 'pt', 'ro', 'ru', 'sv', 'tr'
# html_search_language = 'en' # noqa:E265

# A dictionary with options for the search language support, empty by default.
# Now only 'ja' uses this config value
# html_search_options = {'type': 'default'} # noqa:E265

# The name of a javascript file (relative to the configuration directory) that
# implements a search results scorer. If empty, the default will be used.
# html_search_scorer = 'scorer.js' # noqa:E265

# Output file base name for HTML help builder.
htmlhelp_basename = "%sdoc" % module_nospace

# -- Options for LaTeX output ---------------------------------------------

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    #'papersize': 'letterpaper', # noqa:E265
    # The font size ('10pt', '11pt' or '12pt').
    #'pointsize': '10pt', # noqa:E265
    # Additional stuff for the LaTeX preamble.
    #'preamble': '', # noqa:E265
    # Latex figure (float) alignment
    #'figure_align': 'htbp', # noqa:E265
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (
        master_doc,
        "%s.tex" % module_nospace,
        u"%s Documentation" % project,
        author,
        "manual",
    )
]

# The name of an image file (relative to this directory) to place at the top of
# the title page.
# latex_logo = None # noqa:E265

# For "manual" documents, if this is true, then toplevel headings are parts,
# not chapters.
# latex_use_parts = False # noqa:E265

# If true, show page references after internal links.
# latex_show_pagerefs = False # noqa:E265

# If true, show URL addresses after external links.
# latex_show_urls = False # noqa:E265

# Documents to append as an appendix to all manuals.
# latex_appendices = [] # noqa:E265

# If false, no module index is generated.
# latex_domain_indices = True # noqa:E265


# -- Options for manual page output ---------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, module_lowercase, u"%s Documentation" % project, [author], 1)
]

# If true, show URL addresses after external links.
# man_show_urls = False # noqa:E265


# -- Options for Texinfo output -------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (
        master_doc,
        module_nospace,
        u"%s Documentation" % project,
        author,
        module_nospace,
        module_description,
        "Miscellaneous",
    )
]

# Documents to append as an appendix to all manuals.
# texinfo_appendices = [] # noqa:E265

# If false, no module index is generated.
# texinfo_domain_indices = True # noqa:E265

# How to display URL addresses: 'footnote', 'no', or 'inline'.
# texinfo_show_urls = 'footnote' # noqa:E265

# If true, do not generate a @detailmenu in the "Top" node's menu.
# texinfo_no_detailmenu = False # noqa:E265

todo_include_todos = True

# Example configuration for intersphinx: refer to the Python standard library.
intersphinx_mapping = {"https://docs.python.org/3/": None}


#
# odoo-sphinx-autodoc
#

# sphinxodoo_addons: List of addons name to load (if empty, no addon will be
# loaded)
this_module = os.path.basename(
    os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
)
sphinxodoo_addons = [this_module]
# sphinxodoo_root_path : Path of the Odoo root directory
sphinxodoo_root_path = os.path.dirname(
    os.path.dirname(os.path.abspath(odoo.__file__))
)
# sphinxodoo_addons_path : List of paths were Odoo addons to load are located
superproject_path = os.path.dirname(
    os.path.dirname(os.path.dirname(os.getenv("PWD")))
)
c = ConfigParser.SafeConfigParser()
c.read(os.path.join(superproject_path, "setup.cfg"))
sphinxodoo_addons_path = list()
sphinxodoo_addons_path.append(os.path.join(sphinxodoo_root_path, "addons"))

for line in c.get("odoo_scripts", "modules").splitlines():
    a_path = os.path.dirname(os.path.join(superproject_path, line))
    if a_path not in sphinxodoo_addons_path:
        sphinxodoo_addons_path.append(a_path)
