# -*- coding: utf-8 -*-
##############################################################################
#
#    Email marketing click & read tracker
#    Copyright (C) 2011 Florent Aide, <florent.aide@gmail.com>
#    Copyright (C) 2011, 2015, 2018 XCG Consulting
#                                   (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import logging

from odoo import api, fields, models

logger = logging.getLogger(__name__)


class Mail(models.Model):

    _inherit = "mail.mail"

    track_id = fields.Many2one("marketing.campaign.tracker.track")

    @api.multi
    def _postprocess_sent_message(self, mail_sent=True):
        logger.debug("_postprocess_sent_message in marketing_campaign_tracker")
        for mail in self:
            if mail.track_id:
                values = {"message_uuid": mail.message_id}
                if mail_sent:
                    values["sent"] = fields.Datetime.now()
                # XXX maybe need to use superuser_id there
                mail.track_id.write(values)

        return super(Mail, self)._postprocess_sent_message(mail_sent=mail_sent)


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
