# -*- coding: utf-8 -*-
##############################################################################
#
#    Marketing campaign analytic.
#    Copyright (C) 2011 Florent Aide, <florent.aide@gmail.com>
#    Copyright (C) 2011, 2015 XCG Consulting (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from odoo import api, models


class board_analytic(models.AbstractModel):
    """
        This class Inherits from board.board to override Create function
        to update graphs content when clicking the Update button
    """

    _name = "board.board"
    _inherit = "board.board"

    @api.multi
    def board_update(self):
        campaign_id = self.env.context.get("campaign_id", None)
        if campaign_id:
            self.env["marketing.campaign.tracker.analytic"].update_graphs(
                campaign_id
            )
        return 0
