# -*- coding: utf-8 -*-
###############################################################################
#
#    Odoo, Open Source Management Solution
#    Copyright (C) 2015 XCG Consulting (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

from odoo.tests import TransactionCase


class TestMarketingCampaign(TransactionCase):
    """Unit test similar to those done by OCA
    """

    def setUp(self):
        super(TestMarketingCampaign, self).setUp()
        self.campaign1 = self.env["marketing.campaign"].create(
            {
                "name": "Campaign Test",
                "object_id": self.env["ir.model"]
                .search([("model", "=", "res.partner")], limit=1)
                .id,
            }
        )
        self.campaign_activity1 = self.env[
            "marketing.campaign.activity"
        ].create({"name": "Activity 1", "campaign_id": self.campaign1.id})
        self.track1 = self.env["marketing.campaign.tracker.track"].create(
            {"campaign_activity_id": self.campaign_activity1.id}
        )

    def test_unlink(self):
        result = self.campaign1.unlink()
        self.assertTrue(result, "Unlink should not fail")
