###############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2018 XCG Consulting (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################
from odoo.tests import TransactionCase


class TestTrackEvent(TransactionCase):
    def test_last_event_type(self):
        track_01 = self.browse_ref("marketing_campaign_tracker.track_01")
        self.assertEqual("visit", track_01.last_event_type)
        self.env["marketing.campaign.tracker.track.event"].sudo(
            self.ref("marketing_campaign_tracker.user_bounced")
        ).create(
            {
                "track_id": self.ref("marketing_campaign_tracker.track_01"),
                "event_datetime": "2018-10-23 15:58:41",
                "type": "fake",
            }
        )
        self.assertEqual("fake", track_01.last_event_type)
        self.env["marketing.campaign.tracker.track.event"].sudo(
            self.ref("marketing_campaign_tracker.user_bounced")
        ).create(
            {
                "track_id": self.ref("marketing_campaign_tracker.track_01"),
                "event_datetime": "2018-10-23 15:58:43",
                "type": "something",
            }
        )
        self.assertEqual("something", track_01.last_event_type)
        self.env["marketing.campaign.tracker.track.event"].sudo(
            self.ref("marketing_campaign_tracker.user_bounced")
        ).create(
            {
                "track_id": self.ref("marketing_campaign_tracker.track_01"),
                "event_datetime": "2018-10-23 15:58:33",
                "type": "something else",
            }
        )
        self.assertEqual("something", track_01.last_event_type)
        track_01.opened = "2018-10-23 14:58:33"
        self.assertEqual("something", track_01.last_event_type)
        track_01.opened = "2018-10-23 16:58:33"
        self.assertEqual("open", track_01.last_event_type)
