###############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2019 XCG Consulting (http://www.xcg-consulting.fr/)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################
from odoo.tests import TransactionCase


class TestTrackitem(TransactionCase):
    def setUp(self):
        super(TestTrackitem, self).setUp()
        track_model = self.env["marketing.campaign.tracker.track"]
        vals = {
            "campaign_activity_id": self.ref(
                "marketing_campaign.marketing_campaign_activity_0"
            )
        }
        self.track_id = track_model._create_batch(vals)

    def test_create_batch_minimal(self):
        trackitem_model = self.env["marketing.campaign.tracker.trackitem"]
        vals = {"track_id": self.track_id, "trackitem_uuid": "123"}
        trackitem_id = trackitem_model._create_batch(vals)
        trackitem = trackitem_model.browse(trackitem_id)
        self.assertEqual(trackitem.track_id.id, self.track_id)

    def test_create_batch(self):
        trackitem_model = self.env["marketing.campaign.tracker.trackitem"]
        vals = {
            "track_id": self.track_id,
            "trackitem_uuid": "123",
            "real_url": "https://www.xcg-consulting.fr/",
            "callback": "set_opened",
            "display_id": 1,
            "type": "link",
            "category": "stuff",
        }
        trackitem_id = trackitem_model._create_batch(vals)
        trackitem = trackitem_model.browse(trackitem_id)
        for key, value in vals.items():
            self.assertEqual(getattr(trackitem, key), value)
